﻿Imports System
Imports System.Reflection
Imports System.Text.RegularExpressions
Imports Microsoft.Win32

Module Module1

    Public Const rKeyName As String = "Software\InaSoftAns\mlrep\CurrentVersion" ' レジストリキー

    Function Main(ByVal cmdArgs() As String) As Integer

        ' ■引数が指定されていなかった場合はコマンドライン引数の情報を表示する
        If cmdArgs.Length = 0 Then
            Console.WriteLine("複数行置換コマンドライン版 ver.1.82  (C)2012 T.Yabuki")
            Console.WriteLine("テキストファイルに対する複数行文字列の置換を行います。このプログラムを実行するには、複数行置換GUI版(mlrep.exe) ver.1.82以上が必要です。")
            Console.WriteLine()
            Console.WriteLine("mlrepc [options] </e:置換前文字列 | /e@置換前文字列記述ファイル> </a:置換後文字列 | /a@置換後文字列記述ファイル> </d:対象フォルダ名のフルパス> </n:対象ファイル名>")
            Console.WriteLine()
            Console.WriteLine("・options：")
            Console.WriteLine("　/S  … サブフォルダも検索する")
            Console.WriteLine("　/KB … 置換前ファイルを ～.bak という名前で待避する")
            Console.WriteLine("　/KC:待避先フォルダ … 置換前ファイルを待避先フォルダへ待避する")
            Console.WriteLine("　/R  … 置換前文字列の指定に正規表現を利用する")
            Console.WriteLine("　/I  … /R利用時に、英大小文字を区別しない")
            Console.WriteLine("　/G  … /R利用時に、単一行モードとして動作する")
            Console.WriteLine("　/M  … /R利用時に、複数行モードとして動作する")
            Console.WriteLine("　/U  … ファイルの文字コードを自動判別する(誤判断があり得るのでバックアップを確実に取得すること)")
            Console.WriteLine("　/O:文字コード … /Uを利用しない場合、あるいは/Uで判断不可となった場合の採用される文字コード。")
            Console.WriteLine("・文字コード：")
            Console.WriteLine("　文字コードには、次のいずれかを指定します。")
            Console.WriteLine("　sjis, euc, jis, utf7, utf8, utf8n, utf16, utf16n, utf16be, utf16ben, utf32, utf32n, utf32be, utf32ben, ebcdic")
            Console.WriteLine()
            Console.WriteLine("・対象フォルダ・対象ファイル・置換前後文字列の指定方法について：")
            Console.WriteLine("　GUI版と異なり、カンマ区切りなどにより複数指定はありません。")
            Console.WriteLine("　本コマンドラインを複数回実行することを想定しています。")
            Console.WriteLine()
            Return 0
        End If

        Dim i As Integer

        Dim bSubFolder As Boolean = False
        Dim bBakB As Boolean = False
        Dim bBakC As Boolean = False
        Dim strBakC As String = ""
        Dim bRegExp As Boolean = False
        Dim bRegExpI As Boolean = False
        Dim bRegExpG As Boolean = False
        Dim bRegExpM As Boolean = False
        Dim bAutoDetect As Boolean = False
        Dim iCharCode As Integer = 0

        Dim strBefore As String = Nothing
        Dim strAfter As String = Nothing
        Dim strFolder As String = "."
        Dim strFile As String = Nothing

        ' 引数の解析
        For i = 0 To cmdArgs.Length - 1
            If cmdArgs(i).Chars(0) = "/"c OrElse cmdArgs(i).Chars(0) = "-"c Then
                If cmdArgs(i).Length = 2 AndAlso Char.ToUpper(cmdArgs(i).Chars(1)) = "S"c Then
                    bSubFolder = True

                ElseIf cmdArgs(i).Length = 3 AndAlso
                       Char.ToUpper(cmdArgs(i).Chars(1)) = "K"c AndAlso Char.ToUpper(cmdArgs(i).Chars(2)) = "B"c Then
                    If bBakC = True Then
                        Console.WriteLine("mlrepc: 不正なオプション - /KB と /KC を同時に指定できません。")
                        Return 1
                    End If
                    bBakB = True

                ElseIf cmdArgs(i).Length > 4 AndAlso
                       Char.ToUpper(cmdArgs(i).Chars(1)) = "K"c AndAlso Char.ToUpper(cmdArgs(i).Chars(2)) = "C"c AndAlso cmdArgs(i).Chars(3) = ":"c Then
                    If bBakB = True Then
                        Console.WriteLine("mlrepc: 不正なオプション - /KB と /KC を同時に指定できません。")
                        Return 1
                    End If
                    bBakC = True
                    strBakC = cmdArgs(i).Substring(4)

                ElseIf cmdArgs(i).Length = 2 AndAlso Char.ToUpper(cmdArgs(i).Chars(1)) = "R"c Then
                    bRegExp = True

                ElseIf cmdArgs(i).Length = 2 AndAlso Char.ToUpper(cmdArgs(i).Chars(1)) = "I"c Then
                    bRegExpI = True

                ElseIf cmdArgs(i).Length = 2 AndAlso Char.ToUpper(cmdArgs(i).Chars(1)) = "G"c Then
                    bRegExpG = True

                ElseIf cmdArgs(i).Length = 2 AndAlso Char.ToUpper(cmdArgs(i).Chars(1)) = "M"c Then
                    bRegExpM = True

                ElseIf cmdArgs(i).Length = 2 AndAlso Char.ToUpper(cmdArgs(i).Chars(1)) = "U"c Then
                    bAutoDetect = True

                ElseIf cmdArgs(i).Length > 3 AndAlso
                       Char.ToUpper(cmdArgs(i).Chars(1)) = "O"c AndAlso cmdArgs(i).Chars(2) = ":"c Then
                    iCharCode = getCharCodeIndex(cmdArgs(i).Substring(3))
                    If iCharCode = -1 Then
                        Console.WriteLine("mlrepc: 不正な文字コード指定 - " + cmdArgs(i))
                        Return 1
                    End If

                ElseIf cmdArgs(i).Length > 3 AndAlso
                       Char.ToUpper(cmdArgs(i).Chars(1)) = "E"c AndAlso cmdArgs(i).Chars(2) = ":"c Then
                    strBefore = cmdArgs(i).Substring(3)

                ElseIf cmdArgs(i).Length > 3 AndAlso
                       Char.ToUpper(cmdArgs(i).Chars(1)) = "E"c AndAlso cmdArgs(i).Chars(2) = "@"c Then
                    Try
                        strBefore = My.Computer.FileSystem.ReadAllText(cmdArgs(i).Substring(3))
                    Catch ex As Exception
                        Console.WriteLine("mlrepc: 置換前文字列ファイルを開けません - " + cmdArgs(i))
                        Console.WriteLine(ex.ToString)
                        Return 1
                    End Try

                ElseIf cmdArgs(i).Length > 3 AndAlso
                       Char.ToUpper(cmdArgs(i).Chars(1)) = "A"c AndAlso cmdArgs(i).Chars(2) = ":"c Then
                    strAfter = cmdArgs(i).Substring(3)

                ElseIf cmdArgs(i).Length > 3 AndAlso
                       Char.ToUpper(cmdArgs(i).Chars(1)) = "A"c AndAlso cmdArgs(i).Chars(2) = "@"c Then
                    Try
                        strAfter = My.Computer.FileSystem.ReadAllText(cmdArgs(i).Substring(3))
                    Catch ex As Exception
                        Console.WriteLine("mlrepc: 置換後文字列ファイルを開けません - " + cmdArgs(i))
                        Console.WriteLine(ex.ToString)
                        Return 1
                    End Try

                ElseIf cmdArgs(i).Length > 3 AndAlso
                       Char.ToUpper(cmdArgs(i).Chars(1)) = "D"c AndAlso cmdArgs(i).Chars(2) = ":"c Then
                    strFolder = cmdArgs(i).Substring(3)

                ElseIf cmdArgs(i).Length > 3 AndAlso
                       Char.ToUpper(cmdArgs(i).Chars(1)) = "N"c AndAlso cmdArgs(i).Chars(2) = ":"c Then
                    strFile = cmdArgs(i).Substring(3)

                Else
                    Console.WriteLine("mlrepc: 不正なオプション - " + cmdArgs(i))
                    Return 1

                End If

            Else
                Console.WriteLine("mlrepc: 不正な引数 - " + cmdArgs(i))
                Return 1

            End If

        Next

        If strBefore Is Nothing OrElse strAfter Is Nothing OrElse strFolder Is Nothing OrElse strFile Is Nothing Then
            Console.WriteLine("mlrepc: 必要な引数がそろっていません。最低でも、置換前文字列、置換後文字列、ファイル名は指定する必要があります。")
            Return 1
        End If



        ' ■レジストリへの書き込み
        Try
            Dim rKey As RegistryKey = Registry.CurrentUser.CreateSubKey(rKeyName)
            If Not rKey Is Nothing Then
                With rKey
                    .SetValue("FolderName", strFolder)
                    .SetValue("FileName", strFile)
                    .SetValue("CheckBox_SubFolder", bSubFolder)
                    .SetValue("CheckBox_MultiCSVDir", 0)
                    .SetValue("CheckBox_MultiCSV", 0)
                    .SetValue("CheckBox_Backup", IIf(bBakB OrElse bBakC, 1, 0))
                    .SetValue("CheckBox_RegExp", bRegExp)
                    .SetValue("Check_ICase", bRegExpI)
                    .SetValue("Check_Single", bRegExpG)
                    .SetValue("Check_Multiline", bRegExpM)
                    .SetValue("ComboBox_Encodings_Index", iCharCode)
                    .SetValue("Check_AutoDetect", bAutoDetect)
                    .SetValue("TextBox_Before", strBefore)
                    .SetValue("TextBox_After", strAfter)
                    .SetValue("Radio_BakSel", IIf(bBakB, 0, 1))
                    .SetValue("TextBox_BakFolder", strBakC)
                    .SetValue("CheckBox_SelectFiles", 0)
                    .SetValue("chkMore", 0)
                    .SetValue("CheckBox_IgnoreErr", 0)

                    ' 開いたレジストリキーを閉じる
                    .Close()
                End With
            End If

        Catch ex As Exception
            Console.WriteLine("mlrepc: レジストリキーを開けません - " + rKeyName)
            Console.WriteLine(ex.ToString)

            Return 1

        End Try

        ' ■mlrepプロセスのプログラム名称の決定
        Dim moduleArray() As [Module]

        moduleArray = [Assembly].GetExecutingAssembly().GetModules(False)
        Dim myModule As [Module] = moduleArray(0)
        Dim exename As String = myModule.FullyQualifiedName
        Dim reg As New Regex("\\mlrepc.exe$", RegexOptions.IgnoreCase)
        exename = reg.Replace(exename, "\\mlrep.exe")


        ' ■mlrepプロセスの実行
        Dim p As New Process
        p.StartInfo.UseShellExecute = False
        p.StartInfo.RedirectStandardOutput = True
        p.StartInfo.FileName = exename
        p.StartInfo.Arguments = "/CUIMODE"
        p.Start()


        ' ■ウェイト
        'p.WaitForInputIdle()
        'p.WaitForExit()
        ' キックしたEXEの標準出力をパイプで読み出しコンソールへ書き込み
        Dim reader As System.IO.StreamReader = p.StandardOutput
        Do
            Do While reader.Peek > 0

                Dim buf(1000) As Char
                Dim len As Integer

                len = reader.Read(buf, 0, buf.Length)

                Dim strRead As New String(buf, 0, len)
                Console.Write(strRead)
            Loop

        Loop Until p.WaitForExit(100)

        ' 最後まで
        Console.Write(reader.ReadToEnd())

        ' ■プロセスの終了
        Return p.ExitCode

    End Function

    ' 文字コード名称を、mlrep内のインデックスに書き換える
    Function getCharCodeIndex(ByVal strCharCode As String) As Integer
        ' sjis, euc, jis, utf7, utf8, utf8n, utf16, utf16n, utf16be, utf16ben, utf32, utf32n, utf32be, utf32ben, ebcdic
        strCharCode = strCharCode.ToLower()

        If strCharCode = "sjis" OrElse strCharCode = "shiftjis" OrElse strCharCode = "shift-jis" Then
            Return 0

        ElseIf strCharCode = "utf16" OrElse strCharCode = "utf-16" Then
            Return 1

        ElseIf strCharCode = "euc" OrElse strCharCode = "eucjp" OrElse strCharCode = "euc-jp" Then
            Return 2

        ElseIf strCharCode = "jis" OrElse strCharCode = "iso-2022-jp" Then
            Return 3

        ElseIf strCharCode = "utf7" OrElse strCharCode = "utf-7" Then
            Return 4

        ElseIf strCharCode = "utf8" OrElse strCharCode = "utf-8" Then
            Return 5

        ElseIf strCharCode = "utf32" OrElse strCharCode = "utf-32" OrElse strCharCode = "utf32le" OrElse strCharCode = "utf-32le" Then
            Return 6

        ElseIf strCharCode = "utf16n" OrElse strCharCode = "utf-16n" OrElse strCharCode = "utf16nle" OrElse strCharCode = "utf-16nle" Then
            Return 7

        ElseIf strCharCode = "utf8n" OrElse strCharCode = "utf-8n" Then
            Return 8

        ElseIf strCharCode = "utf32n" OrElse strCharCode = "utf-32n" OrElse strCharCode = "utf32nle" OrElse strCharCode = "utf-32nle" Then
            Return 9

        ElseIf strCharCode = "utf16be" OrElse strCharCode = "utf-16be" Then
            Return 10

        ElseIf strCharCode = "utf32be" OrElse strCharCode = "utf-32be" Then
            Return 11

        ElseIf strCharCode = "utf16ben" OrElse strCharCode = "utf-16ben" Then
            Return 12

        ElseIf strCharCode = "utf32ben" OrElse strCharCode = "utf-32ben" Then
            Return 13

        ElseIf strCharCode = "ebcdic" OrElse strCharCode = "ebcdik" Then
            Return 14

        Else
            Return -1

        End If

    End Function

End Module
